var __defProp = Object.defineProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __publicField = (obj, key, value) => __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
import * as Cesium from "cesium";
const TOKEN = {
  ion: "eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJqdGkiOiI2ODJjZTgxMS0zNmI3LTQwMDgtOTZlMy0xNWI3MTEyMDQ4OTgiLCJpZCI6MjQ0NzMwLCJpYXQiOjE3Mjc1MTg3MzB9.HPtOmmj8PAV1zA5kOrpa6y4WDxO09gTdrJ1kOpeLQvs",
  bing: "AmXdbd8UeUJtaRSn7yVwyXgQlBBUqliLbHpgn2c76DfuHwAXfRrgS5qwfHU6Rhm8",
  arcgis: "AAPTxy8BH1VEsoebNVZXo8HurCkMWha0sqTIHjJ7Kmyjnr0_xVm7HJC7jPO0L3ovWsry1LpumpBKX4JamNUtI3sG9ZE3Iw95Pnjmi6rqYdMMjmYS7d866ISJMHyQCHPdFRdNdluH1J0sq98gHxOi2FzMfKLydLUUXVkj_sbdis-uETZLnz1F-WJ-eBJc9-dCjhO4Kizbko0LrOjiHb69e7P9idm4WSDP1Dk3ZVybL6jjCEE.AT1_SJvq3Xsq"
};
class BaseClass {
  constructor(options) {
    /**
     * 当前类的构造参数
     */
    __publicField(this, "options");
    this.options = options;
  }
  // TODO 销毁
  destroy() {
  }
  /**
   * ### 绑定指定类型事件监听器
   * ---  
   * @param type 事件类型
   * @param callback 回调函数
   * @param [context] 侦听器上下文 this 的指向
   * @param [once] 是否为单次监听
   * @returns 当前实例, 可用于链式调用
   */
  on() {
    return this;
  }
  /**
   * ### 解除绑定指定类型事件监听器
   * ---  
   * @param type 事件类型
   * @param [callback] 回调函数
   * @param [context] 侦听器上下文 this 的指向
   * @returns 当前实例, 可用于链式调用
   */
  off() {
    return this;
  }
}
const defaultMapOptions = {
  control: {
    animation: false,
    baseLayerPicker: false,
    fullscreenButton: false,
    vrButton: false,
    geocoder: false,
    infoBox: false,
    sceneModePicker: false,
    selectionIndicator: false,
    timeline: false,
    navigationHelpButton: false,
    navigationInstructionsInitiallyVisible: false,
    homeButton: false
  },
  baseLayer: false,
  scene: {
    scene3DOnly: false,
    shouldAnimate: true
  },
  baseMaps: [],
  layers: []
};
const mergeMap = (target, ...sources) => {
  if (!sources.length) return target;
  const source = sources.shift();
  if (typeof target === "object" && typeof source === "object") {
    for (const key in source) {
      if (source[key] && typeof source[key] === "object") {
        if (!target[key]) Object.assign(target, { [key]: {} });
        mergeMap(target[key], source[key]);
      } else {
        Object.assign(target, { [key]: source[key] });
      }
    }
  }
  return mergeMap(target, ...sources);
};
const deepClone = (source) => {
  if (typeof source !== "object" || source === null) {
    return source;
  }
  if (Array.isArray(source)) {
    return source.map((item) => deepClone(item));
  }
  const target = {};
  for (const key in source) {
    if (source.hasOwnProperty(key)) {
      target[key] = deepClone(source[key]);
    }
  }
  return target;
};
const uuid = () => {
  var uuidValue = "", k, randomValue;
  for (k = 0; k < 32; k++) {
    randomValue = Math.random() * 16 | 0;
    if (k == 8 || k == 12 || k == 16 || k == 20) {
      uuidValue += "-";
    }
    uuidValue += (k == 12 ? 4 : k == 16 ? randomValue & 3 | 8 : randomValue).toString(16);
  }
  return uuidValue;
};
const comm = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  uuid
}, Symbol.toStringTag, { value: "Module" }));
const Tools = {
  ...comm
};
const BaseLayer = class extends BaseClass {
  constructor(options) {
    super();
    __publicField(this, "id");
    __publicField(this, "name");
    __publicField(this, "show");
    __publicField(this, "type");
    __publicField(this, "_layer");
    __publicField(this, "_map");
    this.id = options.id || Tools.uuid(), this.name = options.name || "";
    this.show = options.show !== void 0 ? options.show : true;
    this.type = options.type;
  }
  set layer(value) {
    var _a;
    this._layer = value;
    if (this._map && value) {
      (_a = this._map.viewer) == null ? void 0 : _a.imageryLayers.add(value);
    }
  }
  get layer() {
    return this._layer;
  }
  /**
   * 将图层添加到地图
   */
  addToMap(map) {
    var _a, _b;
    this._map = map;
    if (this._layer && !((_a = this._map.viewer) == null ? void 0 : _a.imageryLayers.contains(this._layer))) {
      (_b = this._map.viewer) == null ? void 0 : _b.imageryLayers.add(this._layer);
    }
    return this;
  }
};
var LayerType;
((LayerType2) => {
  ((LayerEnum2) => {
    LayerEnum2["Image"] = "image";
    LayerEnum2["Bing"] = "bing";
    LayerEnum2["ArcGIS"] = "arcgis";
    LayerEnum2["OSM"] = "osm";
  })(LayerType2.LayerEnum || (LayerType2.LayerEnum = {}));
})(LayerType || (LayerType = {}));
const TransformRectangle = (rectangle) => {
  return rectangle ? Cesium.Rectangle.fromDegrees(rectangle[0], rectangle[2], rectangle[1], rectangle[3]) : Cesium.Rectangle.MAX_VALUE;
};
const LayerUtil = class {
  /**
   * 创建单张图片图层ImageryProvider
   * @param options 单张图层配置
   */
  static createSingleTileImageryProvider(options) {
    const tileWidth = options.tileWidth ? options.tileWidth : 256;
    const tileHeight = options.tileHeight ? options.tileHeight : 256;
    return new Cesium.SingleTileImageryProvider({
      ...options,
      rectangle: TransformRectangle(options.rectangle),
      tileWidth,
      tileHeight
    });
  }
  /**
   * 创建必应图层
   * @param options bing图层配置
   * @returns 
   */
  static async createBingMapsImageryProvider(options) {
    return await Cesium.BingMapsImageryProvider.fromUrl(
      "https://dev.virtualearth.net",
      {
        ...options,
        key: (options == null ? void 0 : options.key) || TOKEN.bing
      }
    );
  }
  /**
   * 创建ArcGis图层
   * @param options 
   */
  static async crerateArcGisMapServerImageryProvider(options) {
    return await Cesium.ArcGisMapServerImageryProvider.fromUrl(
      "https://ibasemaps-api.arcgis.com/arcgis/rest/services/World_Imagery/MapServer",
      {
        ...options,
        // @ts-ignore
        token: options.token || TOKEN.arcgis
      }
    );
  }
  static createOsmImageryProvider(options) {
    return new Cesium.OpenStreetMapImageryProvider({
      url: (options == null ? void 0 : options.url) || "https://tile.openstreetmap.org/"
    });
  }
  /**
   * 根据参数创建imageryLayerProvider
   * @param options 图层配置
   * @returns 
   */
  static async createImageryLayerProvider(options) {
    switch (options.type) {
      case LayerType.LayerEnum.Image:
        return this.createSingleTileImageryProvider(options);
      case LayerType.LayerEnum.Bing:
        return await this.createBingMapsImageryProvider(options);
      case LayerType.LayerEnum.ArcGIS:
        return this.crerateArcGisMapServerImageryProvider(options);
      case LayerType.LayerEnum.OSM:
        return this.createOsmImageryProvider(options);
      default:
        return await this.createBingMapsImageryProvider();
    }
  }
  /**
   * 根据参数创建各类型基础图层
   * @param options 图层配置
   * @returns 
   */
  static createBaseLayer(options) {
    switch (options.type) {
      case LayerType.LayerEnum.Image:
        return new layer.ImageLayer(options);
      case LayerType.LayerEnum.Bing:
        return new layer.BingLayer(options);
      case LayerType.LayerEnum.ArcGIS:
        return new layer.ArcGisLayer(options);
      case LayerType.LayerEnum.OSM:
        return new layer.OSMLayer(options);
    }
  }
  /**
   * 构造创建图层公共参数
   */
  static _createImageLayerOptions(options) {
    return {
      ...options,
      show: options.show !== false,
      rectangle: TransformRectangle(options.rectangle)
    };
  }
};
const TerrainUtil = class {
  // TODO: 创建地形
  static createTerrainProvider() {
  }
};
const ImageLayer = class extends BaseLayer {
  constructor(options) {
    super(options);
    this.layer = new Cesium.ImageryLayer(
      LayerUtil.createSingleTileImageryProvider(options),
      LayerUtil._createImageLayerOptions(options)
    );
  }
};
const BingLayer = class extends BaseLayer {
  constructor(options) {
    super(options);
    LayerUtil.createBingMapsImageryProvider(options).then((provider) => {
      this.layer = new Cesium.ImageryLayer(provider, LayerUtil._createImageLayerOptions(options));
    });
  }
};
const ArcGisLayer = class extends BaseLayer {
  constructor(options) {
    super(options);
    LayerUtil.crerateArcGisMapServerImageryProvider(options).then((provider) => {
      this.layer = new Cesium.ImageryLayer(provider, LayerUtil._createImageLayerOptions(options));
    });
  }
};
const OSMLayer = class extends BaseLayer {
  constructor(options) {
    super(options);
    this.layer = new Cesium.ImageryLayer(
      LayerUtil.createOsmImageryProvider(options),
      LayerUtil._createImageLayerOptions(options)
    );
  }
};
const layer = {
  /**
   * 基础图层
   */
  BaseLayer,
  /**
   * 单张图片图层
   */
  ImageLayer,
  /**
   * 必应图层
   */
  BingLayer,
  /**
   * ArcGis图层
   */
  ArcGisLayer,
  /**
   * OSM图层
   */
  OSMLayer,
  /**
   * 图层工具类
   */
  LayerUtil,
  /**
   * 地形工具类
   */
  TerrainUtil
};
class BaseMap extends BaseClass {
  constructor(id, options) {
    super();
    /**
     * 地图容器id
     */
    __publicField(this, "id");
    __publicField(this, "imageryProviderViewModels", []);
    /**
     * ### 地图基础类的构造参数
     */
    __publicField(this, "options");
    /**
     * ### Cesium原生 Viewer 对象 
     * ---
     * @link [Cesium.Viewer](https://cesium.com/learn/cesiumjs/ref-doc/Viewer.html)
     */
    __publicField(this, "viewer");
    this.id = id;
    this.options = mergeMap(deepClone(defaultMapOptions), options);
    this.imageryProviderViewModels = this.createImageryProviderViewModels() || [];
    this.createViewer().then((viewer) => {
      this.viewer = viewer;
      this.init();
    });
  }
  // #region 创建cesium viewer
  init() {
    this.setToken();
    this.initLayer();
  }
  // create cesium viewer
  async createViewer() {
    const { control } = this.options;
    const { scene } = this.options;
    const viewer = new Cesium.Viewer(this.id, {
      animation: control == null ? void 0 : control.animation,
      baseLayerPicker: control == null ? void 0 : control.baseLayerPicker,
      fullscreenButton: control == null ? void 0 : control.fullscreenButton,
      vrButton: control == null ? void 0 : control.vrButton,
      geocoder: control == null ? void 0 : control.geocoder,
      infoBox: control == null ? void 0 : control.infoBox,
      homeButton: control == null ? void 0 : control.homeButton,
      sceneModePicker: control == null ? void 0 : control.sceneModePicker,
      selectionIndicator: control == null ? void 0 : control.selectionIndicator,
      timeline: control == null ? void 0 : control.timeline,
      navigationHelpButton: control == null ? void 0 : control.navigationHelpButton,
      navigationInstructionsInitiallyVisible: control == null ? void 0 : control.navigationInstructionsInitiallyVisible,
      scene3DOnly: scene == null ? void 0 : scene.scene3DOnly,
      imageryProviderViewModels: this.imageryProviderViewModels,
      selectedImageryProviderViewModel: this.getSelectedImageryProviderViewModel(),
      baseLayer: await this.createBaseLayer()
    });
    return viewer;
  }
  // #endregion
  // 创建基础图层
  createImageryProviderViewModels() {
    const { baseMaps } = this.options;
    return baseMaps == null ? void 0 : baseMaps.map((item) => {
      const provider = new Cesium.ProviderViewModel({
        name: item.name || "",
        iconUrl: item.iconUrl || "",
        tooltip: item.tooltip || "",
        creationFunction: () => {
          return layer.LayerUtil.createImageryLayerProvider(item);
        }
      });
      return provider;
    });
  }
  async createBaseLayer() {
    const { control, baseLayer } = this.options;
    if ((control == null ? void 0 : control.baseLayerPicker) === true || !baseLayer) return false;
    const provider = await layer.LayerUtil.createImageryLayerProvider(baseLayer);
    return new Cesium.ImageryLayer(provider);
  }
  /**
   * 获取当前选择的图层
   */
  getSelectedImageryProviderViewModel() {
    const { baseMaps, control } = this.options;
    if (!(control == null ? void 0 : control.baseLayerPicker)) return void 0;
    const selectIdx = (baseMaps == null ? void 0 : baseMaps.findIndex((item) => item.selected === true)) || -1;
    if (this.imageryProviderViewModels.length) {
      return this.imageryProviderViewModels[selectIdx];
    }
  }
  // 初始化可叠加图层
  initLayer() {
    var _a, _b;
    for (const item of ((_a = this.options) == null ? void 0 : _a.layers) || []) {
      (_b = layer.LayerUtil.createBaseLayer(item)) == null ? void 0 : _b.addToMap(this);
    }
  }
  // #region 设置token
  setToken() {
    var _a;
    const tokenObj = Object.assign(TOKEN, ((_a = this.options) == null ? void 0 : _a.token) || {});
    const { ion } = tokenObj;
    ion && (Cesium.Ion.defaultAccessToken = ion);
  }
  // #endregion
  // destroy cesium viewer
  destroy() {
    var _a, _b;
    (_a = this.viewer) == null ? void 0 : _a.imageryLayers.removeAll(true);
    (_b = this.viewer) == null ? void 0 : _b.destroy();
  }
}
export {
  BaseMap,
  LayerType,
  Tools,
  layer
};
